﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication5
{
    // une classe Personne avec 3 propriétés et accesseurs respectifs.
    class Personne
    {
        // Accesseurs : getters & setters en C# 3.0
        public int Age { get; set; }
        public string Prenom { get; set; }
        public string Nom { get; set; }

        // Une méthode affichant les infos sur une liste de personnes
        public static void displayList(List<Personne> list)
        {
            foreach(Personne p in list)
                Console.WriteLine("Nom : "+p.Nom+", Prenom : "+p.Prenom+", Age : "+p.Age);
        }

        // Notre méthode d'affichage avec le délégué Predicate<T> en paramètre.
        public static void displayAdultPersonne(List<Personne> listPersonnes, Predicate<Personne> filter)
        {
            // contiendra la liste des adultes
            List<Personne> adults = new List<Personne>();

            foreach (Personne p in listPersonnes)
                if (filter(p))
                    adults.Add(p);

            Personne.displayList(adults);
        }  
    }

}
